function FEDEMloads(Fdist,dTstr)
% Assign distributed load in Fdist to Fedem
% dTstr = time step


[NosZ NosT] = size(Fdist);
Ttop = NosT;
Tlow = 1;
%% Generate load files
cd force_files;
for i = 1:NosZ
    FID = fopen(['triad' num2str(i+Tlow-1) 'load.txt'],'w'); i
    for j = 1:NosT
        fprintf(FID,[num2str((j-1)*dTstr) '     ' num2str(Fdist(i,j)) '\n']);
    end
    fclose all;
end
cd ..; cd ..;

%% Generate C#-file
cd Csharp;
FIDr = fopen('cs_text.txt','r'); cd fedem1;
FIDw = fopen('form1.cs','w'); cd ..; cd ..;

% Find HERE1
while 1
	temp = fgetl(FIDr);
    if strfind(temp,'HERE1')
        break
    else
        fprintf(FIDw,[temp '\n']);
    end
end
% Create triad and function names
for i = Tlow:Ttop
    fprintf(FIDw,['FEDEM.ITriad triad'   num2str(i) '; \n']);
    fprintf(FIDw,['FEDEM.IFunction func' num2str(i) '; \n']);
end

% Find HERE2
while 1
	temp = fgetl(FIDr);
    if strfind(temp,'HERE2')
        break
    else
        fprintf(FIDw,[temp '\n']);
    end
end
% Create triad identites and functions
% Triad1 must be on bottom in the model!
home = pwd;
temp = strfind(home,'\');
    for i = 1:length(temp)
        home = [home(1:temp(i)+3*i-3) '\\\' home((temp(i)+3*i-2):end)];
    end
for i = Tlow:Ttop
    fprintf(FIDw,['triad' num2str(i)  ' = fedApp.FindByDescription("triad' num2str(i) '");\n']);          
    fprintf(FIDw,['func'  num2str(i)  ' = fedApp.CreateFunction(FEDEM.FunctionUsageType.fuGeneral, "MyFunc");\n']);
    fprintf(FIDw,['func'  num2str(i)  '.SetPolylineFromFile("' home '\\\\Csharp\\\\force_files\\\\triad' num2str(i) 'load.txt");\n']);
end

% Find HERE3
while 1
	temp = fgetl(FIDr);
    if strfind(temp,'HERE3')
        break
    else
        fprintf(FIDw,[temp '\n']);
    end
end
% Set free each triad and link to respective function
for i = Tlow:Ttop
    fprintf(FIDw,['triad' num2str(i) '.get_DOF(FEDEM.DOFType.All).SetFree(0);\n']);
    fprintf(FIDw,['triad' num2str(i) '.get_DOF(FEDEM.DOFType.TX).SetFree(0, func' num2str(i) ');\n']);
end

% Write end of file
while 1
	temp = fgetl(FIDr);
    if temp == -1
        break
    else
        fprintf(FIDw,[temp '\n']);
    end
end
fclose all;

%% Open form1.cs
 ButtonName = questdlg('Do you need to assign new files to new triads?', ...
                         'C# Application', ...
                         'Yes, open', 'No', 'No');
   switch ButtonName,
     case 'Yes, open',
         system('Csharp\fedem1.sln');
         return
     case 'No'
         return
   end