%% User input %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fill in all the required field in the UI (user input) structure!
% Calls: mainFNV(UI) from directory main_functions
%% Constants
UI.rho  = 1025;                      % water density [kg/m^3]
UI.g    = 9.81;                      % gravity acceleration [m/s^2];
%% Monopile parameters
UI.h = 25;
UI.D = 6;
UI.Cm = 2;
UI.Cd = 1;
% Sea state parameters
UI.gam = 4;
UI.Hs  = 10;
UI.Tp  = 12;
UI.seed= 1:4;
UI.Wmax= sqrt(2*UI.g/UI.Hs);
% Vertical node coordinates on tower
UI.Zvec = [-25:5:-10 -9:10 15];
% Time vector
UI.time = 300; 
UI.dt   = 0.5;
%% Run calculation
cd main_functions
mainFNV(UI);