%% User input %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fill in all the required field in the UI (user input) structure!
% Calls: embedDNV(UI)
%% Monopile parameters
UI.h = 25;
UI.D = 6;
UI.Cm = 2;
UI.Cd = 1;
% Vertical node coordinates on tower
UI.Zvec = [-25:5:-10 -9:10 15];
% Time vector
UI.time = 100;     % embedding right after time/2. Time duration extended with T!
UI.dt   = 1;
% wave parameters
UI.H     = 12;
UI.T     = 10;
UI.ORDER = 10;   % order of stream function wave theory
% Sea state
UI.gam     = 3;
UI.Hs      = 8;
UI.Tp      = 10;
UI.seed    = 1;
UI.optWave = 1;
UI.Wmax    = 3;
%% Wave calculation options
UI.optWave = 1;
%  1           2                 3
% linear    %2nd order deep   %2nd order finite
%% Wave calculation options
UI.optKine = 7;
%   4      5          6      7         8
%expol1  %expol2  %expol3  %wheel1  %wheel2
%% Constants
UI.rho  = 1025;                      % water density [kg/m^3]
UI.g    = 9.81;                      % gravity acceleration [m/s^2];
%% Run calculation
cd main_functions
embedDNV(UI);