%% User input %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fill in all the required field in the UI (user input) structure!
% Calls: embedFIT(UI)
%% Monopile parameters
UI.h = 25;
UI.D = 6;
UI.Cm = 2;
UI.Cd = 1;
% Vertical node coordinates on tower
UI.Zvec = [-25:5:-10 -9:10 15];
% Time vector
UI.time    = 300; 
UI.dt      = 1;
UI.Tcutoff = 70;  % time before and after event in the result output series
% wave parameters
UI.H     = 7;
UI.T     = 10;
UI.ORDER = 10;   % order of stream function wave theory
% Sea state
UI.gam     = 3;
UI.Hs      = 13;
UI.Tp      = 10;
UI.seed    = 1:10;
UI.optWave = 1;
UI.Wmax    = 3;
%% Where to embed wave?
UI.optExtr = 2; 
%   1                       2                         3  
% max(Ac) to min(At)   % max(Ac) to mean(At)   % max wave heigth
%% Wave calculation options
UI.optWave = 1;
%  1           2                 3
% linear    %2nd order deep   %2nd order finite
%% Wave calculation options
UI.optKine = 1;
%   4      5          6      7         8
%expol1  %expol2  %expol3  %wheel1  %wheel2
%% Constants
UI.rho  = 1025;                      % water density [kg/m^3]
UI.g    = 9.81;                      % gravity acceleration [m/s^2];
%% Run calculation
cd main_functions
embedFIT(UI);