%% User input %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fill in all the required field in the UI (user input) structure!
% Calls: mainIrregular(UI) from directory main_functions
%% Constants
UI.rho  = 1025;                      % water density [kg/m^3]
UI.g    = 9.81;                      % gravity acceleration [m/s^2];
%% Monopile parameters
UI.h = [25 30];      % h = [h1 h2] -> h1 = linear, h2 = 2nd order
UI.D = 6;
UI.Cm = 2;
UI.Cd = 1;
% Sea state parameters
UI.gam = 4;
UI.Hs  = 10;
UI.Tp  = 12;
UI.seed= 1;
UI.Wmax= sqrt(2*UI.g/UI.Hs);
% Vertical node coordinates on tower
UI.Zvec = [-25:5:-10 -9:10 15];
% Time vector
UI.time = 300; 
UI.dt   = 0.5;
%% Wave calculation options
UI.optWave = [1];
%  1           2                 3
% linear    %2nd order deep   %2nd order finite
%% Kinematic calculation options
UI.optKine = [5];
%  0      1        2        3        4         5       6         7       8
%none  %linear  %2nd_deep  %second  %expol1  %expol2  %expol3  %wheel1  %wheel2
%% Run calculation
cd main_functions
mainIrregular(UI);