function out = DistProperty(Zvec,Pdist,eta)
% out = DistProperty(Zvec,Fdist,eta)
% Input:  Vertical coordinates along structure, a matrix of distributed
% property, like velocity and acceleration matrix as used throughout the
% code
% Output: out is matrix, with the property "lumped" to nodes by the
% trapezoidal rule, equal to "morisonL.m"
cd ..
% Integration to z=0, if linear, deep2 or secfin!
temp = size(Pdist);
if temp(1) == length(Zvec)
    temp = min(find(Pdist==0))
    Fsur = Pdist(temp,:);
    eta  = Fsur*0;
else
    Fsur = Pdist(1,:);
    Pdist(1,:) = [];
end

out = Pdist*0;
for i = 1:length(Pdist(1,:))
    loc= max(find(Zvec<=eta(i)));     % highest submerged point on monopile!
        z1 = Zvec(1);
        z2 = (Zvec(2)+Zvec(1))/2;
        out(1,i) = (z2-z1)*Pdist(1,i);
    for j = 2:(loc-1)
        z1 = z2;
        z2 = (Zvec(j+1)+Zvec(j))/2;   % mean of the two points
        out(j,i) = (z2-z1)*Pdist(j,i);
    end
        z1 = z2;
        z2 = Zvec(loc);
        out(loc,i) = (z2-z1)*Pdist(loc,i);
        z1 = z2;
        z2 = eta(i);
        out(loc,i) = (z2-z1)*(Pdist(loc,i)+Fsur(i))/2 + out(loc,i);
end