function out = mosionL(Cm,Cd,D,h,Zvec,eta,U,A)
% out = mosionL(Cm,Cd,D,h,Zvec,eta,U,A)
% See morison2.m
% This function do the same, but the distributed loads is lumped to the
% nodes specified in Zvec


cd ..
rho   = 1025;
g     = 9.81;
Fdist = rho*Cm*pi*D^2/4*A + rho*D/2*Cd*U.*abs(U);

% Integration to z=0, if linear, deep2 or secfin!
temp = size(Fdist);
if temp(1) == length(Zvec)
    temp = min(find(Fdist==0))
    Fsur = Fdist(temp,:);
    eta  = Fsur*0;
else
    Fsur = Fdist(1,:);
    Fdist(1,:) = [];
end

% Integration to actual elevation!
out = Fdist*0;
for i = 1:length(Fdist(1,:))
    loc= max(find(Zvec<=eta(i)));     % highest submerged point on monopile!
        z1 = Zvec(1);
        z2 = (Zvec(2)+Zvec(1))/2;
        out(1,i) = (z2-z1)*Fdist(1,i);
    for j = 2:(loc-1)
        z1 = z2;
        z2 = (Zvec(j+1)+Zvec(j))/2;   % mean of the two points
        out(j,i) = (z2-z1)*Fdist(j,i);
    end
        z1 = z2;
        z2 = Zvec(loc);
        out(loc,i) = (z2-z1)*Fdist(loc,i);
        z1 = z2;
        z2 = eta(i);
        out(loc,i) = (z2-z1)*(Fdist(loc,i)+Fsur(i))/2 + out(loc,i);
end