%% Wave numbers
function K = wave_number(W,h)
% K = wave_number(W,h)
% Input:  Matrix Frequencies, water depth
% Output: Matrix of Wave numbers corresponding to W
% Calculation by iteration process, linear dispersion relation

cd ..;
g = 9.81;

for i = 1:size(W,1)
    for j = 1:size(W,2)
        k    = 0;
        knew = W(i,j)^2/g;
        while abs(knew - k) > 0.0005
            k    = knew;
            knew = W(i,j)^2/(g*tanh(k*h));
        end
        K(i,j)   = knew;              % Wave number corresponding to W(i)
    end
end