%% Blend stream function with irregular sea
function Znew = blend(Tvec,T,Zirr,Zemb)
% Znew = blend(Tvec,T,Zirr,Zemb)
% Input:  Time vector, Wave period, Irregular stochastic matrix, embedded
% matrix
% Output: Matrix blended solution
% Blend Zirr and Zemb, both have the embedding location (crest of wave) at
% time 0
Znew = Zirr*0;

for i = 1:length(Tvec)
    t = Tvec(i);
    if      abs(t) > 0.75*T
        Firr = 1;
        Femb = 0;
    elseif  abs(t) < 0.5*T
        Firr = 0;
        Femb = 1;
    else
        Firr = 0.5-0.5*cos(  4*pi*(abs(t)/T-0.5)  );
        Femb = 0.5+0.5*cos(  4*pi*(abs(t)/T-0.5)  );
    end
    
    Znew(:,i) = Zirr(:,i)*Firr + Zemb(:,i)*Femb;
end