%% Stream function coefficients
function STAT = read_output(NR,NORDER)
% STAT = read_output(NR,NORDER)
% Input:  number of run, order of theory
% Output: STAT, structure containing Stream function coefficients and
% information about each embedding location as T and H
% Read output given by the Fortran Routine

cd ..;
% read from file!

cd dean_fortran;
FID = fopen('embedding_output.dat'); cd ..;

STAT.H     = zeros(1,length(NR));
STAT.T     = zeros(1,length(NR));
STAT.ETA   = zeros(41,length(NR)+1);
STAT.COEFF = zeros(NORDER+2,length(NR));

%% Read data!

for i = 1:length(NR);

    % Find next MAX, Write H and T
    while 1
        temp = fgetl(FID);
        if strfind(temp,'MAXIMUM')
            break
        end
    end
    temp = fgetl(FID); temp = fgetl(FID);
    temp = textscan(temp(10:end),'%f');
    STAT.T(i) = temp{1};
    
    % Write coefficients and height
    while 1
        temp = fgetl(FID);
        if strfind(temp,'FINAL'); break;    end
    end
    while 1
        temp = fgetl(FID);
        if strfind(temp,'STREAM'); break;    end
    end
    temp = fgetl(FID);
    temp = textscan(temp(17:end),'%f');
    eta  = temp{1};                             % (coefficients)
    while 1    
        temp = fgetl(FID);
        if strfind(temp,'WAVE'); break;    end
        temp = textscan(temp(17:end),'%f');
        eta  = [eta; temp{1}];                  % (coefficients)
    end
    STAT.COEFF(:,i) = [eta(1)/3.28084; eta(2:end,1)/3.28084^2]; % change to meter!
    
    % Write H
    temp = textscan(temp(23:30),'%f');
    STAT.H(i) = temp{1}/3.28084;
    
    % Find THETAS and ETAS
    temp = fgetl(FID); temp = fgetl(FID);
    eta  = textscan(temp,'%f'); eta = eta{1};
    while 1    
        temp = fgetl(FID);
        if strfind(temp,'RUN'); break;    end
        if strfind(temp,'END'); break;    end
        temp = textscan(temp,'%f');
        eta  = [eta ;  temp{1}];
    end
    STAT.ETA(:,1)   = eta(1:2:end);
    STAT.ETA(:,i+1) = eta(2:2:end)/3.28084;
    
end

fclose all;
clear eta J B %k;