function STAT = read_output2(NR,NORDER)
%% Stream function coefficients
% See "read_output.m"
% This function do the same, but reads the output when Fortran is allowed
% to continue to the next embedding location, after the computation has
% failed due to wave breaking.

cd ..;
% read from file!

cd dean_fortran;
FID = fopen('embedding_output.dat'); cd ..;

STAT.H     = zeros(1,length(NR));
STAT.T     = zeros(1,length(NR));
STAT.ETA   = zeros(41,length(NR)+1);
STAT.COEFF = zeros(NORDER+2,length(NR));

%% Read data!
i = 0;
while i < length(NR)
    BRW = 0;
    i   = i+1
    %% Find next MAX, Write H and T
    while 1
        temp = fgetl(FID);
        if strfind(temp,'MAXIMUM')
            break
        end
    end
    temp = fgetl(FID); temp = fgetl(FID);
    temp = textscan(temp(10:end),'%f');
    STAT.T(i) = temp{1};
    %% Write coefficients and height
    while 1
        temp = fgetl(FID);
        if strfind(temp,'FINAL');          break;    end
        if strfind(temp,'FJOMP'); BRW = 1; break;    end
    end
    if BRW == 1
    else
    while 1
        temp = fgetl(FID);
        if strfind(temp,'STREAM'); break;    end
    end
    temp = fgetl(FID);
    temp = textscan(temp(17:end),'%f');
    eta  = temp{1};                             % (coefficients)
    while 1    
        temp = fgetl(FID);
        if strfind(temp,'WAVE'); break;    end
        temp = textscan(temp(17:end),'%f');
        eta  = [eta; temp{1}];                  % (coefficients)
    end
    STAT.COEFF(:,i) = [eta(1)/3.28084; eta(2:end,1)/3.28084^2]; % change to meter!
    %% Write H
    temp = textscan(temp(23:30),'%f');
    STAT.H(i) = temp{1}/3.28084;
    %% Find THETAS and ETAS
    temp = fgetl(FID); temp = fgetl(FID);
    eta  = textscan(temp,'%f'); eta = eta{1};
    while 1    
        temp = fgetl(FID);
        if strfind(temp,'RUN'); break;    end
        if strfind(temp,'END'); break;    end
        temp = textscan(temp,'%f');
        eta  = [eta ;  temp{1}];
    end
    STAT.ETA(:,1)   = eta(1:2:end);
    STAT.ETA(:,i+1) = eta(2:2:end)/3.28084;
    end
end

fclose all;