function [U,A] = K1linear(LIN,Tvec,Zvec,h,nr)
% Calculates linear kinematic
W  = LIN.W;
K  = LIN.K;
Za = LIN.Za;
eps= LIN.eps;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lam  = 2*pi./K;                    % lam goes from long to short
tinf = min(find(lam  <  h/20));    % tinf = index of the largest lam shorter than h/20
if isempty(tinf)
    tinf = length(K)+1;
    lam  = [];
end
U    = zeros(length(Zvec),length(Tvec)); A = U;
temp = K*0;
for i = 1:length(Zvec)
    z    = Zvec(i);
    [nr z]
    temp(1:tinf-1) = W(1:tinf-1).*Za(1:tinf-1).* ...
                      cosh(K(1:tinf-1)*(z+h))./sinh(K(1:tinf-1)*h); % finite water
	if (1-isempty(lam))
	temp(tinf:end) = W(tinf:end).*Za(tinf:end).*exp(K(tinf:end)*z); % deep water
    end
    if z > 0; break; end
    for j = 1:length(Tvec)
        t      = Tvec(j);
        U(i,j) = sum(   temp.*cos(-W*t + eps));
        A(i,j) = sum(W.*temp.*sin(-W*t + eps));
    end
end
clear temp t z j i tinf lam