%% Wave spectra
function [Y,W] = WaveSpectra2nd(Y,W,Hs,opt)
% Cut wave spectra sqrt(2g/Hs), used for 2nd order processess
% opt = 1, Y = S-values
% opt = 2, Y = Za-values
if   opt == 1
    S  = Y;
else
    dW = W(2)-W(1);
    S  = 0.5*Y.^2/dW;
end

%% Cut Specter at W2nd, if: W(end) > W2nd
Nmax = length(W); % either restricted by Wmax or Wny
W2nd = sqrt(2*9.81/Hs);
N2nd = min(find(W>=W2nd));
if isempty(N2nd) == 0
    W = W(1:N2nd);
    S = S(1:N2nd);
    % Create fading, but no longer than the original Wmax!
    N = min([ceil(N2nd/4) Nmax-N2nd]);
    W = [W          W(end)+(W(2)-W(1))*(1:N)];
    S = [S(1:end-1) linspace(S(end),0,  N+1)];
end

%% Create output according to: opt
if   opt == 1
    Y = S;
else
    Y = sqrt(2*S*dW);
end