%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculation of Low waves and low-low interactions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
alf = alf0(1:N); Za = Za0(1:N); K = K0(1:N); eps = eps0(1:N); W = W0(1:N);

% Matrices
for j = 1:N
    ALFj(:,j) = alf;  % different in vertical direction (j-direction, rows)
    ALFi(j,:) = alf;  % different in horizontal direction (i-direction, coloumns)
     Zaj(:,j) = Za;
     Zai(j,:) = Za;
      Wj(:,j) = W;
      Wi(j,:) = W;
      Kj(:,j) = K;
      Ki(j,:) = K;
end
Wneg = Wj-Wi;
Wpos = Wj+Wi;
LAM = Wi./Wj;

temp = LAM.^2*(ALFi.^2-1)-2*LAM.*(ALFi.*ALFj-1)+ALFj.^2-1;
temp = (2*LAM.*(1-LAM).*(ALFi.*ALFj+1)-LAM.^3.*(ALFi.^2-1)+ALFj.^2-1)/temp;
RXij = (ALFi*ALFj-1)/2*temp;
Aneg = RXij.*Zai*Zaj*Wj;
tneg = (Kj-Ki).*Aneg./cosh(abs(Kj-Ki)*h);

temp = LAM.^2*(ALFi.^2-1)-2*LAM.*(ALFi.*ALFj+1)+ALFj.^2-1;
temp = (2*LAM.*(1+LAM).*(ALFi.*ALFj-1)+LAM.^3.*(ALFi.^2-1)+ALFj.^2-1)/temp;
SXij = -(ALFi*ALFj+1)/2*temp;
Apos = SXij.*Zai*Zaj*Wj;
tpos = (Kj+Ki).*Apos./cosh(abs(Kj+Ki)*h);

for j = 1:N 
    tpos(j,j:end) = tpos(j,j:end)*0;
    tneg(j,j:end) = tneg(j,j:end)*0;
end

% Calculation
% i = coloums (horizontal)
% j = rows    (coloumns)
for i = 1:length(Tvec)
    t = Tvec(i);
    for j = 1:N
        THj(:,j) = -W*t + eps;
        THi(j,:) = -W*t + eps;
    end
    for j = 1:length(Zvec)
        z = Zvec(j);
        Ul(i,j) = sum(  Za.*K.*   cosh(  K*(z+h))./cosh(K*h).*cos(  THi(1,:)) ...
                      + 3/8*Za.^2.*W.*2.*K.*cosh(2*K*(z+h))./cosh(K*h).*cos(2*THi(1,:))  );
        Ul(i,j) = sum( sum( tneg.*cosh(abs(Kj-Ki)*(z+h)).*cos(THj-THi) ...
                             + tpos.*cosh(abs(Kj+Ki)*(z+h)).*cos(THj+THi) )) + Ul(i,j);
    end
end
%clear Ki Kj tmin tpos THi THj Zai Zaj Wi Wj ALFi ALFj RXij SXij Apos Aneg LAM


%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculation of high frequency wave interactions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
alf = alf0(1:M); Za= Za0(1:M); K = K0(1:M); eps = eps0(1:M); W = W0(1:M);
for j = 1:M
    Ki(j,:)  = K;
    Kj(:,j)  = K;
    Ei(j,:)  = eps;
    Ej(:,j)  = eps;
    Wi(j,:)  = W;
    Wj(:,j)  = W;
    Ai(j,:)  = Za*g./W;
    Aj(:,j)  = Za*g./W;
end
tmin = zeros(M);
for j = 2:M
    for i = 1:j
         tmin(j,i) = K(i)*K(j)/W(i);
    end
end
Kneg = Kj-Ki;
Wneg = Wj-Wi;
tmin = -tmin.*Kneg.*Ai.*Aj;

clear THj THi
for i = 1:length(Tvec)
    t = Tvec(i);
    THj = -Wj*t + Ej;
	THi = -Wi*t + Ei;
    for j = 1:length(Zvec)
        z = Zvec(j);
        U_SS(i,j) =  sum(sum(       tmin.*exp(Kneg*z).*cos(THj-THi)  ));
        A_SS(i,j) =  sum(sum( Wneg.*tmin.*exp(Kneg*z).*sin(THj-THi)  ));
    end
end
%clear Ki Kj tmin THi THj LAM













%        Al(i,j) = sum(  Za.*K.*W.*cosh(  K*(z+h))./cosh(K*h).*sin(  THi(1,:)) ...
%                      + 3/8*Za.^2.*K.*W.^2.*cosh(2*K*(z+h))./cosh(K*h).*sin(2*THi(1,:))  );
%        Al(i,j) = sum( sum( Wneg.*tneg.*cosh(abs(Kj-Ki)*(z+h)).*sin(THj-THi) ...
%                           + Wpos.*tpos.*cosh(abs(Kj+Ki)*(z+h)).*sin(THj+THi) )) + Ul(i,j);
