% Waves
cd ..;
g = 9.81;

[M N] = max(S);
N     = ceil(N*1.5);  % upper limit for Low frequencies
M     = floor(N/3);   % lower limit for Low frequencies
W     = ETA.W(M:end); % cutting in paramteters from wave spectra
Za    = ETA.Za(M:end);
eps   = ETA.eps(M:end);
N     = N - M + 1;    % Change the upper limit number in the cutted vectors
M     = length(W);   % Length of cutted vectors
cd irregular_sea;
K     = zhang_wavenumber(W,Za,h,N);
alf   = coth(K*h);
Zvec  = Zvec(1:  max(find(Zvec<=0))  );

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculation of high frequency wave interactions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ETA.Za  =  Za(N+1:M); ETA.K   =   K(N+1:M);
ETA.eps = eps(N+1:M); ETA.W   =   W(N+1:M);
cd irregular_sea;
[VEL, ACC] = wave_kinematics(Tvec,Zvec,h,ETA,2,2,1);
Uss = VEL.deep2-VEL.linear;
Ass = ACC.deep2-ACC.linear;
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculation of Low waves and low-low interactions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ETA.Za  =  Za(1:N);   ETA.K   =   K(1:N);
ETA.eps = eps(1:N);   ETA.W   =   W(1:N);
cd irregular_sea;
[VEL, ACC] = wave_kinematics(Tvec,Zvec,h,ETA,3,2,1);
Ul  = VEL.second;
Al  = ACC.second;
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate the interaction between lower and upper range   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j = 1:M-N             % rows = high frequencies
    Zai(j,:) = Za(1:N);  % for use in sum of low frequencies
    Ki(j,:)  = K(1:N);
    ALFi(j,:)= alf(1:N);
    Wi(j,:)  = W(1:N);
end  
for j = 1:N
    Wj(:,j)  = W(N+1:M);
    Kj(:,j)  = K(N+1:M);
end
LAM = Wi./Wj;
RHO = 2*ALFi + (ALFi-1./ALFi).*(LAM.*ALFi)./(2-LAM.*ALFi);
TAU = (ALFi-1./ALFi).*(1-LAM.*ALFi)./((2-LAM.*ALFi).^2-LAM);
GAM = -TAU.*LAM./(2-LAM.*ALFi);

Us = zeros(length(Zvec),length(Tvec));
for i = 1:length(Tvec)
    t = Tvec(i);
    for j = 1:(M-N)      % for use in sum of low frequencie
        THi(j,:)    = -W(1:N)*t + eps(1:N);
    end
    
    THj = -W(N+1:M)'*t + eps(N+1:M)';
    
    % summation over low frequencies, rows (i)    
    faj  = 1 + sum(  Zai.*Ki.*   TAU.*cos(THi) ,2);
   dfaj  =     sum( -Zai.*Ki.^2.*TAU.*cos(THi) ,2); % = faj'
    
    for j = 1:length(Zvec)
        z = Zvec(j);
        temp = RHO+LAM.*Ki./Kj-cosh(Ki*(z+h))./sinh(Ki*h);
        THhj = THj       + K(N+1:M)'.*sum( Zai.*    sin(THi).*temp ,2);
       dTHhj = K(N+1:M)' + K(N+1:M)'.*sum( Zai.*Ki.*cos(THi).*temp ,2);
        
        fkj  = z*sum( (1+Zai.*Ki.*RHO.*cos(THi))     - ...
                         Zai.*cos(THi).*sinh(Ki*(z+h))./sinh(Ki*h)     ,2);
       dfkj  = z*sum( ( -Zai.*Ki.*RHO.*sin(THi)).*Ki + ...
                     Ki.*Zai.*sin(THi).*sinh(Ki*(z+h))./sinh(Ki*h)     ,2);
                     
        Lcj  = sum(Zai.*Ki.*   cos(THi).*( TAU.*(cosh(Ki*z)-1)+ ...
                GAM.*sinh(Ki*z)+Kj./Ki.*RHO.*(sinh(Ki*z)-Ki*z) )       ,2);
       dLcj  =-sum(Zai.*Ki.^2.*sin(THi).*( TAU.*(cosh(Ki*z)-1)+ ...
                GAM.*sinh(Ki*z)+Kj./Ki.*RHO.*(sinh(Ki*z)-Ki*z) )       ,2);
    
        Lsj  = sum(Zai.*Ki.*   sin(THi).*( TAU.*(cosh(Ki*z)-1)+ ...
                GAM.*sinh(Ki*z)+Kj./Ki.*RHO.*(sinh(Ki*z)-Ki*z) )       ,2);
       dLsj  = sum(Zai.*Ki.^2.*cos(THi).*( TAU.*(cosh(Ki*z)-1)+ ...
                GAM.*sinh(Ki*z)+Kj./Ki.*RHO.*(sinh(Ki*z)-Ki*z) )       ,2);
    
        % summation over high frequencies, coloumns (j)    
        Us1(j,i) = sum( g.*Za(N+1:M)'./W(N+1:M)'.*(dfaj+dLcj).*                 exp(fkj.*K(N+1:M)').*sin(THhj)        );
        Us2(j,i) = sum( g.*Za(N+1:M)'./W(N+1:M)'.*  faj.*      K(N+1:M)'.*dfkj.*exp(fkj.*K(N+1:M)').*sin(THhj)        );
        Us3(j,i) = sum( g.*Za(N+1:M)'./W(N+1:M)'.*  faj.*                       exp(fkj.*K(N+1:M)').*cos(THhj).*dTHhj );    

        Us4(j,i) = sum( g.*Za(N+1:M)'./W(N+1:M)'.*dLsj.*                        exp(fkj.*K(N+1:M)').*cos(THhj)        );
        Us5(j,i) = sum( g.*Za(N+1:M)'./W(N+1:M)'.* Lsj.*       K(N+1:M)'.*dfkj.*exp(fkj.*K(N+1:M)').*cos(THhj)        );
        Us6(j,i) = sum(-g.*Za(N+1:M)'./W(N+1:M)'.* Lsj.*                        exp(fkj.*K(N+1:M)').*sin(THhj).*dTHhj );
    end
end