function K = zhang_wavenumber(W,Za,h,N)
% Iteration process to find the modified K-values in the upper spectra
% The change in K values in the lower spectra is assumed to be of even
% higher orders

g   = 9.81;
cd ..; cd diverse;
K   = wave_number(W,h);
M   = length(W);
alf = coth(K(1:N)*h);

K0 = K;
for i = 1:100
    for j = N+1:M-1
        LAMj = W(1:N)./W(j);
        Pj   = (1-alf.*LAMj).*LAMj.^3./(4*(1-alf.*LAMj)+(alf.^2-1).*LAMj.^2);
        Pj   = 1/8*(alf.^2-1).^2.*LAMj.^2 + 1/8*(LAMj.^2-1).^2.*(alf-1./alf).*Pj;
        Pj   = (alf.^2+1 )+1/8*(alf.^2-1).*(3*alf+1./alf).*LAMj + Pj;
        Pj   = LAMj.*K(1:N)*K(j).*Pj;
        LAMj = W./W(j);
        temp = 1 + Za(j)^2*K(j)^2         ...
                 + sum( Za(1:N).^2.*Pj)   ...
                 + K(j)*sum(Za(N+1:j-1).^2.*K(N+1:j-1).*LAMj(N+1:j-1)) ...
                 + K(j)*sum(Za(j+1:M  ).^2.*K(j+1:M  ).*LAMj(j+1:M  ));
        K(j) = W(j)^2/(temp*g);
    end
end

%(K./K0)'
