function mainFNV(UI)
%% FNV load calculation
% Calls: FNVcalc.m
%        wave_number.m

cd ..; home = pwd;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% User input %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h       = UI.h;
D       = UI.D;
Cm      = UI.Cm;
Cd      = UI.Cd;
gam     = UI.gam;
Hs      = UI.Hs;
Tp      = UI.Tp;
Wmax    = UI.Wmax;
NR      = UI.seed;
Zvec    = UI.Zvec;
time    = UI.time;
dt      = UI.dt;
rho     = UI.rho;
g       = UI.g;              
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Wave spectra
cd irregular_sea
Tvec  = [0:dt:time];
[S,W] = WaveSpectra(Hs,Tp,Tvec,Wmax,gam);
%% Irregular surface and kinematics
for i = NR
    cd irregular_sea;
    res = FNVcalc(Cm,Cd,D,h,S,W,Tvec,Zvec,i);
    % Save output for run
    save(['run' num2str(i)],'res'); 
end
INFO.h   = h;      INFO.HsTpGam = [Hs Tp gam];
INFO.Zvec= Zvec;   INFO.dt = dt; INFO.time = time; 
INFO.WS  = [W; S]; INFO.CmCd = [Cm Cd];
type = 'FNV load model';
for i = NR
	temp = load(['run' num2str(i)]);
    FM.(['run' num2str(i)])(1,:) = temp.res.FM(1,:);
    FM.(['run' num2str(i)])(2,:) = temp.res.FM(2,:);
    Fdist.(['run' num2str(i)])   = temp.res.Fdist;
end
save('FNV','type','INFO','FM','Fdist');