function STR = stream(Tvec,Zvec,H,T,h,NORDER)
% Stream function wave
% Wave: Z = Za*cos(k*x - w*t)
% Calls: wave_number.m
%       !embedding2.exe
%        read_output
%        stream_kinematics

cd ..
cd dean_fortran;
NR = 1;
FID = fopen('embedding_input.dat','w'); cd ..;
% Write: depth, number of points for VELOC, number of realizations, NORDER
fprintf(FID,[num2str(h*3.28084) '     ' num2str(20) '     ' ...
             num2str(NR)        '     ' num2str(NORDER) '\n']);
fprintf(FID,[num2str(H*3.28084) '     ' num2str(T) '\n']);
fclose all;

%% Call Executable
cd dean_fortran
!embedding2.exe
cd ..
% Create Executable with NAG Fortran Builder --->
%      *** Run embedding.f from: matlab\embedding
% system('C:\Program Files\NAG\EFBuilder 5.3\bin\FortranBuilder');
%      *** Close FortranBuilder

%% Do calculations    
% read output from fortran
    cd embedding;
	STAT = read_output(NR,NORDER);
% calculate kinematics
    cd regular;
	STR = stream_kinematics(STAT.ETA(:,[1 2]),STAT.COEFF(:,1), ...
                                              STAT.T(1),Zvec,Tvec,h);
STR.COEFF = STAT.COEFF;