function Z = stream_wave(Xvector,Yvector,Vpos)
% Create periodic function of calculated stream function surface by Fortran
% The function spline() is used

cd ..;

L = 2*Xvector(end);

Xtemp = [-L/2 - L/20; Xvector; L/2 + L/20  ];
Ytemp = [Yvector(1) ; Yvector; Yvector(end)];

Z    = Vpos*0;

for i = 1:length(Vpos)    
    Xpos = Vpos(i);
    if     Xpos >  L/2
        while Xpos > L/2
          Xpos = Xpos - L;
        end
    elseif Xpos < -L/2
        while Xpos < -L/2
          Xpos = Xpos + L;
        end
    end
    Z(i) = spline(Xtemp,Ytemp,Xpos);
end